commit 73a1434acadb1f04b161bd9281b5e20b771e2c04
Author: Renato Botelho do Couto <renato@netgate.com>
Date:   Wed Mar 10 10:16:29 2021 -0300

    Welcome pfSense CE 2.5.1-RELEASE

diff --git a/src/etc/phpshellsessions/gitsync b/src/etc/phpshellsessions/gitsync
index 937e55dfae..3c201a34dd 100644
--- a/src/etc/phpshellsessions/gitsync
+++ b/src/etc/phpshellsessions/gitsync
@@ -30,14 +30,14 @@ require_once("pfsense-utils.inc");
 $GIT_PKG = "git"; // Either "git" or the full package URL
 $GIT_BIN= "/usr/local/bin/git";
 $GIT_REPO = "git://github.com/pfsense/pfsense.git";
-$DEFAULT_BRANCH = "RELENG_2_5_0";
+$DEFAULT_BRANCH = "RELENG_2_5_1";
 $CODIR =  "/root/pfsense";
 $GITSYNC_MERGE = "/root/.gitsync_merge";
 
 /* NOTE: Set branches here */
 $branches = array(
 	"master" => "2.6.0 development branch",
-	"RELENG_2_5_0" => "2.5.0 stable branch",
+	"RELENG_2_5_1" => "2.5.1 stable branch",
 	"build_commit" => "The commit originally used to build the image"
 );
 
diff --git a/src/etc/version b/src/etc/version
index f21e5eba43..19ab9dbc6d 100644
--- a/src/etc/version
+++ b/src/etc/version
@@ -1 +1 @@
-2.5.0-RELEASE
+2.5.1-RC
diff --git a/src/usr/local/www/system_update_settings.php b/src/usr/local/www/system_update_settings.php
index 1bdcbdee8d..2cfabb4f12 100644
--- a/src/usr/local/www/system_update_settings.php
+++ b/src/usr/local/www/system_update_settings.php
@@ -206,7 +206,7 @@ if (file_exists("/usr/local/bin/git")) {
 		'Branch name',
 		'text',
 		($gitcfg['branch'] ? $gitcfg['branch'] : '')
-		))->setHelp('The most recently used branch was "%1$s". (Usually the branch name is RELENG_2_5_0)' .
+		))->setHelp('The most recently used branch was "%1$s". (Usually the branch name is RELENG_2_5_1)' .
 					'%2$sNote: Sync will not be performed if a branch is not specified.', $lastbranch, '<br />');
 
 	$group = new Form_Group('Sync options');
diff --git a/tools/builder_defaults.sh b/tools/builder_defaults.sh
index 302d0abd1e..209d432a0b 100644
--- a/tools/builder_defaults.sh
+++ b/tools/builder_defaults.sh
@@ -108,7 +108,7 @@ GIT_REPO_BASE=$(git -C ${BUILDER_ROOT} config --get remote.origin.url | sed -e '
 
 # This is used for using svn for retrieving src
 export FREEBSD_REPO_BASE=${FREEBSD_REPO_BASE:-"${GIT_REPO_BASE}/freebsd-src.git"}
-export FREEBSD_BRANCH=${FREEBSD_BRANCH:-"${REPO_BRANCH_PREFIX}RELENG_2_5_0"}
+export FREEBSD_BRANCH=${FREEBSD_BRANCH:-"${REPO_BRANCH_PREFIX}RELENG_2_5_1"}
 export FREEBSD_SRC_DIR=${FREEBSD_SRC_DIR:-"${SCRATCHDIR}/FreeBSD-src"}
 
 export BUILD_KERNELS=${BUILD_KERNELS:-"${PRODUCT_NAME}"}
@@ -215,7 +215,7 @@ if [ -z "${REPO_BRANCH_PREFIX}" ]; then
 else
 	export POUDRIERE_PORTS_GIT_URL=${POUDRIERE_PORTS_GIT_URL:-"${GIT_REPO_BASE}/${REPO_BRANCH_PREFIX}ports.git"}
 fi
-export POUDRIERE_PORTS_GIT_BRANCH=${POUDRIERE_PORTS_GIT_BRANCH:-"${REPO_BRANCH_PREFIX}RELENG_2_5_0"}
+export POUDRIERE_PORTS_GIT_BRANCH=${POUDRIERE_PORTS_GIT_BRANCH:-"${REPO_BRANCH_PREFIX}RELENG_2_5_1"}
 
 # Use vX_Y instead of RELENG_X_Y for poudriere to make it shorter
 POUDRIERE_PORTS_BRANCH=$(echo "${POUDRIERE_PORTS_GIT_BRANCH}" | sed 's,RELENG_,v,')
@@ -312,7 +312,7 @@ export CORE_PKG_REAL_PATH="${CORE_PKG_PATH}/.real_${DATESTRING}"
 export CORE_PKG_ALL_PATH="${CORE_PKG_PATH}/All"
 
 export PKG_REPO_BASE=${PKG_REPO_BASE:-"${BUILDER_TOOLS}/templates/pkg_repos"}
-export PFSENSE_DEFAULT_REPO="${PRODUCT_NAME}-repo"
+export PFSENSE_DEFAULT_REPO="${PRODUCT_NAME}-repo-251"
 export PKG_REPO_DEFAULT=${PKG_REPO_DEFAULT:-"${PKG_REPO_BASE}/${PFSENSE_DEFAULT_REPO}.conf"}
 export PFSENSE_BUILD_REPO="${PFSENSE_DEFAULT_REPO}"
 export PKG_REPO_BUILD=${PKG_REPO_BUILD:-"${PKG_REPO_BASE}/${PFSENSE_BUILD_REPO}.conf"}
diff --git a/tools/conf/pfPorts/make.conf b/tools/conf/pfPorts/make.conf
index 037e270570..69a17f7c0e 100644
--- a/tools/conf/pfPorts/make.conf
+++ b/tools/conf/pfPorts/make.conf
@@ -1,7 +1,7 @@
 ALLOW_UNSUPPORTED_SYSTEM=yes
 
 # Define pfSense repos
-PFSENSE_REPOS=	%%PRODUCT_NAME%%-repo %%PRODUCT_NAME%%-repo-devel %%PRODUCT_NAME%%-repo-245
+PFSENSE_REPOS=	%%PRODUCT_NAME%%-repo %%PRODUCT_NAME%%-repo-devel %%PRODUCT_NAME%%-repo-245 %%PRODUCT_NAME%%-repo-251
 
 # Generic options
 OPTIONS_UNSET_FORCE=	DOCS DOXYGEN EXAMPLES INFO MAN MANPAGES X11
diff --git a/tools/templates/pkg_repos/pfSense-repo-251.abi b/tools/templates/pkg_repos/pfSense-repo-251.abi
new file mode 100644
index 0000000000..a6d37c2631
--- /dev/null
+++ b/tools/templates/pkg_repos/pfSense-repo-251.abi
@@ -0,0 +1 @@
+FreeBSD:12:%%ARCH%%
diff --git a/tools/templates/pkg_repos/pfSense-repo-251.altabi b/tools/templates/pkg_repos/pfSense-repo-251.altabi
new file mode 100644
index 0000000000..e3479a96e5
--- /dev/null
+++ b/tools/templates/pkg_repos/pfSense-repo-251.altabi
@@ -0,0 +1 @@
+freebsd:12:%%ARCH%%
diff --git a/tools/templates/pkg_repos/pfSense-repo-251.conf b/tools/templates/pkg_repos/pfSense-repo-251.conf
new file mode 100644
index 0000000000..6cde860d74
--- /dev/null
+++ b/tools/templates/pkg_repos/pfSense-repo-251.conf
@@ -0,0 +1,17 @@
+FreeBSD: { enabled: no }
+
+%%PRODUCT_NAME%%-core: {
+  url: "%%PKG_REPO_SERVER_RELEASE%%/%%PRODUCT_NAME%%_%%PKG_REPO_BRANCH_RELEASE%%_%%ARCH%%-core",
+  mirror_type: "srv",
+  signature_type: "fingerprints",
+  fingerprints: "/usr/local/share/%%PRODUCT_NAME%%/keys/pkg",
+  enabled: yes
+}
+
+%%PRODUCT_NAME%%: {
+  url: "%%PKG_REPO_SERVER_RELEASE%%/%%PRODUCT_NAME%%_%%PKG_REPO_BRANCH_RELEASE%%_%%ARCH%%-%%PRODUCT_NAME%%_%%PKG_REPO_BRANCH_RELEASE%%",
+  mirror_type: "srv",
+  signature_type: "fingerprints",
+  fingerprints: "/usr/local/share/%%PRODUCT_NAME%%/keys/pkg",
+  enabled: yes
+}
diff --git a/tools/templates/pkg_repos/pfSense-repo-251.descr b/tools/templates/pkg_repos/pfSense-repo-251.descr
new file mode 100644
index 0000000000..a51848a896
--- /dev/null
+++ b/tools/templates/pkg_repos/pfSense-repo-251.descr
@@ -0,0 +1 @@
+Next pfSense Release Candidate (2.5.1-RC)
diff --git a/tools/templates/pkg_repos/pfSense-repo.conf b/tools/templates/pkg_repos/pfSense-repo.conf
index 6cde860d74..317ab0f544 100644
--- a/tools/templates/pkg_repos/pfSense-repo.conf
+++ b/tools/templates/pkg_repos/pfSense-repo.conf
@@ -1,7 +1,7 @@
 FreeBSD: { enabled: no }
 
 %%PRODUCT_NAME%%-core: {
-  url: "%%PKG_REPO_SERVER_RELEASE%%/%%PRODUCT_NAME%%_%%PKG_REPO_BRANCH_RELEASE%%_%%ARCH%%-core",
+  url: "%%PKG_REPO_SERVER_RELEASE%%/%%PRODUCT_NAME%%_%%REPO_BRANCH_PREFIX%%v2_5_0_%%ARCH%%-core",
   mirror_type: "srv",
   signature_type: "fingerprints",
   fingerprints: "/usr/local/share/%%PRODUCT_NAME%%/keys/pkg",
@@ -9,7 +9,7 @@ FreeBSD: { enabled: no }
 }
 
 %%PRODUCT_NAME%%: {
-  url: "%%PKG_REPO_SERVER_RELEASE%%/%%PRODUCT_NAME%%_%%PKG_REPO_BRANCH_RELEASE%%_%%ARCH%%-%%PRODUCT_NAME%%_%%PKG_REPO_BRANCH_RELEASE%%",
+  url: "%%PKG_REPO_SERVER_RELEASE%%/%%PRODUCT_NAME%%_%%REPO_BRANCH_PREFIX%%v2_5_0_%%ARCH%%-%%PRODUCT_NAME%%_%%REPO_BRANCH_PREFIX%%v2_5_0",
   mirror_type: "srv",
   signature_type: "fingerprints",
   fingerprints: "/usr/local/share/%%PRODUCT_NAME%%/keys/pkg",