commit 0a8a90f77b5e16797748e849322cd5919cc80442
Author: Phil Davis <phil.davis@inf.org>
Date:   Tue Jan 26 23:59:05 2016 +0545

    Internationalize services_d*

diff --git a/src/usr/local/www/services_dhcp.php b/src/usr/local/www/services_dhcp.php
index 18c4e855b0..8a84a848a1 100644
--- a/src/usr/local/www/services_dhcp.php
+++ b/src/usr/local/www/services_dhcp.php
@@ -293,7 +293,7 @@ if (isset($_POST['submit'])) {
 				}
 				if ($cpdata['timeout'] > $deftime) {
 					$input_errors[] = sprintf(gettext(
-						"The Captive Portal zone '%s' has Hard Timeout parameter set to a value bigger than Default lease time (%s)."), $cpZone, $deftime);
+						'The Captive Portal zone (%1$s) has Hard Timeout parameter set to a value bigger than Default lease time (%2$s).'), $cpZone, $deftime);
 				}
 			}
 		}
@@ -1134,8 +1134,8 @@ $section->addClass('adnlopts');
 
 $section->addInput(new Form_StaticText(
 	null,
-	'<div class="alert alert-info"> ' . gettext('Enter the DHCP option number and the value for each item you would like to include in the DHCP lease information. ' .
-	'For a list of available options please visit this ') . '<a href="http://www.iana.org/assignments/bootp-dhcp-parameters/" target="_blank">' . gettext("URL") . '</a></div>'
+	'<div class="alert alert-info"> ' . gettext('Enter the DHCP option number and the value for each item you would like to include in the DHCP lease information.') . ' ' .
+	sprintf(gettext('For a list of available options please visit this %1$s URL%2$s'), '<a href="http://www.iana.org/assignments/bootp-dhcp-parameters/" target="_blank">', '</a></div>')
 ));
 
 if (!$pconfig['numberoptions']) {
diff --git a/src/usr/local/www/services_dhcpv6.php b/src/usr/local/www/services_dhcpv6.php
index 8fdd4ebe10..471ea4ac6c 100644
--- a/src/usr/local/www/services_dhcpv6.php
+++ b/src/usr/local/www/services_dhcpv6.php
@@ -195,7 +195,7 @@ if ($_POST) {
 		do_input_validation($_POST, $reqdfields, $reqdfieldsn, $input_errors);
 
 		if (($_POST['prefixrange_from'] && !is_ipaddrv6($_POST['prefixrange_from']))) {
-			$input_errors[] = gettext("A valid range must be specified.");
+			$input_errors[] = gettext("A valid prefix range must be specified.");
 		}
 		if (($_POST['prefixrange_to'] && !is_ipaddrv6($_POST['prefixrange_to']))) {
 			$input_errors[] = gettext("A valid prefix range must be specified.");
@@ -878,13 +878,19 @@ print($form);
 ?>
 <div class="infoblock blockopen">
 <?php
-print_info_box(gettext('The DNS servers entered in ') . '<a href="system.php">' . gettext(' System: General setup') . '</a>' .
-			   gettext(' (or the ') . '<a href="services_dnsmasq.php"/>' . gettext('DNS forwarder') . '</a>, ' . gettext('if enabled) ') .
-			   gettext('will be assigned to clients by the DHCP server.') . '<br />' .
-			   gettext('The DHCP lease table can be viewed on the ') . '<a href="status_dhcpv6_leases.php">' .
-			   gettext('Status: DHCPv6 leases') . '</a>' . gettext(' page.'),
-			   'info',
-			   false);
+print_info_box(
+	sprintf(
+		gettext('The DNS servers entered in %1$sSystem: General setup%3$s (or the %2$sDNS forwarder%3$s if enabled) will be assigned to clients by the DHCP server.'),
+		'<a href="system.php">',
+		'<a href="services_dnsmasq.php"/>',
+		'</a>') . 
+	'<br />' .
+	sprintf(
+		gettext('The DHCP lease table can be viewed on the %1$sStatus: DHCPv6 leases%2$s page.'),
+		'<a href="status_dhcpv6_leases.php">',
+		'</a>'),
+	'info',
+	false);
 ?>
 </div>
 <div class="panel panel-default">
diff --git a/src/usr/local/www/services_dhcpv6_relay.php b/src/usr/local/www/services_dhcpv6_relay.php
index f6c821d925..c95b0df622 100644
--- a/src/usr/local/www/services_dhcpv6_relay.php
+++ b/src/usr/local/www/services_dhcpv6_relay.php
@@ -118,7 +118,7 @@ if ($_POST) {
 		if ($_POST['server']) {
 			foreach ($_POST['server'] as $checksrv => $srv) {
 				if (!is_ipaddrv6($srv[0])) {
-					$input_errors[] = gettext("A valid Destination Server IPv6 address  must be specified.");
+					$input_errors[] = gettext("A valid Destination Server IPv6 address must be specified.");
 				}
 
 
diff --git a/src/usr/local/www/services_dnsmasq.php b/src/usr/local/www/services_dnsmasq.php
index b0f60fe62e..dffc67fd97 100644
--- a/src/usr/local/www/services_dnsmasq.php
+++ b/src/usr/local/www/services_dnsmasq.php
@@ -344,17 +344,18 @@ print($form);
 ?>
 <div class="infoblock blockopen">
 <?php
-print_info_box(sprintf("If the DNS forwarder is enabled, the DHCP".
-	" service (if enabled) will automatically serve the LAN IP".
-	" address as a DNS server to DHCP clients so they will use".
-	" the forwarder. The DNS forwarder will use the DNS servers".
-	" entered in %sSystem: General setup%s".
-	" or those obtained via DHCP or PPP on WAN if the &quot;Allow".
-	" DNS server list to be overridden by DHCP/PPP on WAN&quot;".
-	" is checked. If you don't use that option (or if you use".
-	" a static IP address on WAN), you must manually specify at".
-	" least one DNS server on the %sSystem:".
-	"General setup%s page.",'<a href="system.php">','</a>','<a href="system.php">','</a>'), 'info', false);
+print_info_box(
+	sprintf(
+		gettext('If the DNS forwarder is enabled, the DHCP service (if enabled) will automatically' .
+			' serve the LAN IP address as a DNS server to DHCP clients so they will use the forwarder.' .
+			' The DNS forwarder will use the DNS servers entered in %1$sSystem: General setup%3$s or' .
+			' those obtained via DHCP or PPP on WAN if &quot;Allow DNS server list to be overridden by DHCP/PPP on WAN&quot; is checked.' .
+			' If you don\'t use that option (or if you use a static IP address on WAN),' .
+			' you must manually specify at least one DNS server on the %2$sSystem:General setup%3$s page.'),
+		'<a href="system.php">',
+		'<a href="system.php">',
+		'</a>'),
+	'info', false);
 ?>
 </div>
 
@@ -435,7 +436,7 @@ endforeach;
 
 <div class="infoblock blockopen">
 <?php
-print_info_box(gettext("Entries in this section override individual results from the forwarders.") .
+print_info_box(gettext("Entries in this section override individual results from the forwarders.") . " " .
 				gettext("Use these for changing DNS results or for adding custom DNS records."), 'info', false);
 ?>
 </div>
diff --git a/src/usr/local/www/services_dnsmasq_domainoverride_edit.php b/src/usr/local/www/services_dnsmasq_domainoverride_edit.php
index b230a4b971..f0ffd9c5d4 100644
--- a/src/usr/local/www/services_dnsmasq_domainoverride_edit.php
+++ b/src/usr/local/www/services_dnsmasq_domainoverride_edit.php
@@ -198,7 +198,7 @@ if (isset($id) && $a_domainOverrides[$id]) {
 		null,
 		'hidden',
 		$pconfig['id']
-	))->setHelp('You may enter a description here for your reference (not parsed).');
+	));
 }
 
 $form->add($section);